clear all
capture log close
set more off
# delimit ;
set matsize 800 ;

/* These directories need to be changed for the files to run properly. This 
should be done in both .do files. */
sysdir set PERSONAL "C:\Ado\" ;
global DO "C:\Users\peter.shirley\Downloads\" ;
global INPUT "C:\Users\peter.shirley\Downloads\" ;
global OUTPUT "C:\Users\peter.shirley\Downloads\" ;
global LOGS "C:\Users\peter.shirley\Downloads\" ;
global FIGURES "C:\Users\peter.shirley\Downloads\" ;

log using "${LOGS}MW_Desc_Author_Groups_Final.log", replace ;

use "${OUTPUT}MW_Papers_1992_2020_Final.dta" ;

bysort paper: keep if _n==1 ;
keep author1 author2 author3 author4 yearmult paper ;
sort author1 author2 author3 author4 yearmult ;

count ;

/* Several exceptions to handle first. */
replace author1="HSKim" if author1=="HS Kim" ;
replace author1="TKim" if author1=="T Kim" ;
replace author2="LeGallo" if author2=="Le Gallo" ;
replace author2="PodemskaMikluch" if author2=="Podemska-Mikluch" ;

preserve ;

forvalues y=1(1)4 { ;

	levelsof author`y', local(authorlist) ;
	
	foreach x of local authorlist { ;

		capture gen `x'=1 ;
		
	} ;
	
	drop author1 author2 author3 author4 yearmult paper ;
	keep if _n==1 ;
	gen num=1 ;
	tempfile authors`y' ;
	save authors`y', replace ;
	restore, preserve ;
	
}  ;

restore, not ;

drop _all ;
use authors1 ;
forvalues y=2(1)4 { ;

	merge 1:1 num using authors`y' ;
	drop _merge ;
	
} ;

drop num ;

gen authorlist="" ;

foreach x of varlist * { ;

	local obs=_N+1 ;
	set obs `obs' ;
	replace authorlist="`x'" in `obs' ;

} ;

keep authorlist ;
drop if _n==1 ;
drop if authorlist=="authorlist" ;

replace authorlist="HS Kim" if authorlist=="HSKim" ;
replace authorlist="T Kim" if authorlist=="TKim" ;
replace authorlist="Le Gallo" if authorlist=="LeGallo" ;
replace authorlist="Podemska-Mikluch" if authorlist=="PodemskaMikluch" ;

sort authorlist ;
gen authorid=_n ;
local totalauthors=_N ;

save "${OUTPUT}Author_List_Final.dta", replace ; 
drop _all ;
use "${OUTPUT}MW_Papers_1992_2020_Final.dta" ;
tempfile placeholder ;
save placeholder, replace ;

forvalues y=1(1)4 { ;

	use "${OUTPUT}Author_List_Final.dta" ;
	rename authorlist author`y' ;
	rename authorid authorid`y' ;
	
	merge 1:m author`y' using placeholder ;
	assert _merge!=2 if author`y'!="" ;
	drop if _merge==1 ;
	drop _merge ;
	save placeholder, replace ;
	drop _all ;
	
} ;

use placeholder ;
keep authorid1 authorid2 authorid3 authorid4 ;
duplicates drop ;
sort authorid1 authorid2 authorid3 authorid4 ;
save placeholder, replace ;

drop _all ;

forvalues y=1(1)`totalauthors' { ;
	
	use placeholder ;
	keep if authorid1==`y' | authorid2==`y' | authorid3==`y' | authorid4==`y' ;
	tempfile placeholder`y' ;
	save placeholder`y', replace ;
	drop _all ;

} ;

forvalues z=1(1)`totalauthors' { ;

	use placeholder`z' ;

	forvalues x=1(1)10 { ;

		forvalues y=1(1)4 { ;
		
			sum authorid`y' in `x' ;
			
			if `r(N)'==0 { ;
		
				continue ;
				
			} ; 
			
			local number=`r(mean)' ;
			append using placeholder`number' ;
			
		} ;
		
	} ;
	
	duplicates drop ;

	count ;
	local studies=`r(N)' ;
	gen authorid=. ;
	
	forvalues x=1(1)`studies' { ;
	
		forvalues y=1(1)4 { ;
		
			local obs=_N+1 ;
			set obs `obs' ;
			replace authorid=authorid`y'[`x'] in `obs' ;
			
		} ;
		
	} ;
	
	gen authorgroup=`z' ;
	keep if _n!=1 ;
	drop if authorid==. ;
	drop authorid1 authorid2 authorid3 authorid4 ;
	duplicates drop ;

	tempfile authorgroup`z' ;
	save authorgroup`z', replace ;
	
} ;

use authorgroup1 ;
forvalues y=2(1)`totalauthors' { ;

	append using authorgroup`y' ;
	
} ;

duplicates drop authorid, force ;
egen authorgroup2=group(authorgroup) ;
drop authorgroup ;
rename authorgroup2 authorgroup ;

merge 1:1 authorid using "${OUTPUT}Author_List_Final.dta" ;
assert _merge==3 ;
drop _merge ;

sum authorgroup ;
local max=`r(max)' ;

forvalues x=1(1)`max' { ;

	display "authorgroup`x'" ;

	tab authorlist if authorgroup==`x' ;
	
} ;

gen groupname="" ; 
replace groupname="Aaronson et al." if authorgroup==1 ;
replace groupname="Addison, Blackburn, & Cotti" if authorgroup==2 ;
replace groupname="Dube, Reich et al." if authorgroup==3 ;
replace groupname="Baiman & Persky" if authorgroup==4 ;
replace groupname="Bailey et al." if authorgroup==5 ;
replace groupname="Bazen & Le Gallo" if authorgroup==6 ;
replace groupname="Brummund & Strain" if authorgroup==7 ;
replace groupname="Sabia, Burkhauser et al." if authorgroup==8 ;
replace groupname="Card, Krueger, & Katz" if authorgroup==9 ;
replace groupname="Clemens & Wither" if authorgroup==10 ;
replace groupname="Currie & Fallick" if authorgroup==11 ;
replace groupname="Deere, Murphy, & Welch" if authorgroup==12 ;
replace groupname="Derenoncourt & Montialoux" if authorgroup==13 ;
replace groupname="Dodson" if authorgroup==14 ;
replace groupname="Even & Macpherson" if authorgroup==15 ;
replace groupname="Gilyard & Podemska-Mikluch" if authorgroup==16 ;
replace groupname="Gittings & Schmutte" if authorgroup==17 ;
replace groupname="Gopalan et al." if authorgroup==18 ;
replace groupname="HS Kim & Jang" if authorgroup==19 ;
replace groupname="Hirsch, Kaufman, & Zelenska" if authorgroup==20 ;
replace groupname="Hoffman & Trace" if authorgroup==21 ;
replace groupname="Liu, Hyclak, & Regmi" if authorgroup==22 ;
replace groupname="Kandilov & Kandilov" if authorgroup==23 ;
replace groupname="Manning" if authorgroup==24 ;
replace groupname="Orazem & Mattila" if authorgroup==25 ;
replace groupname="Meer & West" if authorgroup==26 ;
replace groupname="Michl" if authorgroup==27 ;
replace groupname="Monras" if authorgroup==28 ;
replace groupname="Neumark, Wascher et al." if authorgroup==29 ;
replace groupname="Zavodny & Orrenius" if authorgroup==30 ;
replace groupname="Partridge & Partridge" if authorgroup==31 ;
replace groupname="Phillips, Su, & Wang" if authorgroup==32 ;
replace groupname="Powell" if authorgroup==33 ;
replace groupname="Singell & Terborg" if authorgroup==34 ;
replace groupname="T Kim & Taylor" if authorgroup==35 ;
replace groupname="Thompson" if authorgroup==36 ;
replace groupname="Totty" if authorgroup==37 ;
replace groupname="Williams" if authorgroup==38 ;

save "${OUTPUT}Author_Groups_Final.dta", replace ;
drop _all ;

use "${OUTPUT}MW_Papers_1992_2020_Final.dta" ;
tempfile dataset ;
save dataset, replace ;
drop _all ;

forvalues y=1(1)4 { ;

	use "${OUTPUT}Author_List_Final.dta" ;
	rename authorlist author`y' ;
	rename authorid authorid`y' ;
	
	merge 1:m author`y' using dataset ;
	assert _merge!=2 if author`y'!="" ;
	drop if _merge==1 ;
	drop _merge ;
	save dataset, replace ;
	drop _all ;
	
} ;

forvalues y=1(1)4 { ;

	use "${OUTPUT}Author_Groups_Final.dta" ;
	rename authorid authorid`y' ;
	rename authorgroup authorgroup`y' ;
	merge 1:m authorid`y' using dataset ;
	assert _merge!=2 if author`y'!="" ;
	drop if _merge==1 ;
	drop _merge ;
	save dataset, replace ;
	
} ;

assert authorgroup1==authorgroup2 & authorgroup2==authorgroup3 & authorgroup3==authorgroup4 if author1!="" & author2!="" & author3!="" & author4!="" ;
assert authorgroup1==authorgroup2 & authorgroup2==authorgroup3 if author1!="" & author2!="" & author3!="" ;
assert authorgroup1==authorgroup2 if author1!="" & author2!="" ;
drop authorgroup2 authorgroup3 authorgroup4 ;
rename authorgroup1 authorgroup ;

order author1 authorid1 author2 authorid2 author3 authorid3 author4 authorid4 authors groupname year multiple yearmult paper elasticity estimate_details significance population_of_interest estimate_location variation_type estimate_id ;

save "${OUTPUT}MW_Papers_1992_2020_Final.dta", replace ;

/* Determining number of papers per author */
drop _all ;

use "${OUTPUT}Author_List_Final.dta" ;

levelsof authorlist, local(authorlist) ;

drop _all ;

use "${OUTPUT}MW_Papers_1992_2020_Final.dta" ;

bysort paper: keep if _n==1 ;

foreach x of local authorlist { ;

	display "`x'" ;
	count if author1=="`x'" | author2=="`x'" | author3=="`x'" | author4=="`x'" ;
	
} ;

drop _all ;

/* Determining number of papers per author group */
use "${OUTPUT}MW_Papers_1992_2020_Final.dta" ;

bysort paper: keep if _n==1 ;

tab authorgroup ;

drop _all ;

log close ;
